diff -Naur src.pgsql/backend/access/Makefile src.bitmap/backend/access/Makefile
--- src.pgsql/backend/access/Makefile	2006-09-16 17:51:43.000000000 -0700
+++ src.bitmap/backend/access/Makefile	2006-09-17 00:09:29.000000000 -0700
@@ -8,7 +8,7 @@
 top_builddir = ../../..
 include $(top_builddir)/src/Makefile.global
 
-SUBDIRS	    := common gist hash heap index nbtree transam gin
+SUBDIRS	    := common gist hash heap index nbtree transam gin bitmap
 SUBDIROBJS  := $(SUBDIRS:%=%/SUBSYS.o)
 
 all: SUBSYS.o
diff -Naur src.pgsql/backend/access/bitmap/Makefile src.bitmap/backend/access/bitmap/Makefile
--- src.pgsql/backend/access/bitmap/Makefile	1969-12-31 16:00:00.000000000 -0800
+++ src.bitmap/backend/access/bitmap/Makefile	2006-09-17 00:09:28.000000000 -0700
@@ -0,0 +1,34 @@
+#-------------------------------------------------------------------------
+#
+# Makefile--
+#    Makefile for access/bitmap
+#
+# Copyright (c) 2006, Greenplum, Inc.
+#
+# IDENTIFICATION
+#    $PostgreSQL$
+#
+#-------------------------------------------------------------------------
+
+subdir = src/backend/access/bitmap
+top_builddir = ../../../..
+include $(top_builddir)/src/Makefile.global
+
+OBJS = bitmaputil.o bitmapattutil.o \
+bitmappages.o bitmapinsert.o bitmapsearch.o bitmap.o bitmapxlog.o
+
+all: SUBSYS.o
+
+SUBSYS.o: $(OBJS)
+	$(LD) $(LDREL) $(LDOUT) SUBSYS.o $(OBJS)
+
+depend dep:
+	$(CC) -MM $(CFLAGS) *.c >depend
+
+clean: 
+	rm -f SUBSYS.o $(OBJS)
+
+ifeq (depend,$(wildcard depend))
+include depend
+endif
+
diff -Naur src.pgsql/backend/access/bitmap/README src.bitmap/backend/access/bitmap/README
--- src.pgsql/backend/access/bitmap/README	1969-12-31 16:00:00.000000000 -0800
+++ src.bitmap/backend/access/bitmap/README	2006-09-17 00:09:28.000000000 -0700
@@ -0,0 +1,149 @@
+$PostgreSQL$
+
+This directory contains an implementation of an on-disk bitmap index.
+
+An on-disk bitmap index consists of bitmap vectors, one for each
+distinct value for the attribute(s) to be indexed. Each bit in a bitmap
+vector corresponds to a tuple in the heap. The advantage of
+on-disk bitmap indexes is that they are very small compared to btrees
+when the attributes to be indexed have low cardinalities, that is,
+a small number of distinct values. As a result, on-disk bitmap indexes
+have less construction cost and higher query performance than btrees
+for the low-cardinality attributes.
+
+Contents
+--------
+ * Hybrid Run-Length equality encoding bitmap index
+ * The insertion algorithm
+ * Handling tuples that are inserted in the middle of the heap
+ * Vacuum/Vacuum full
+ * Notes on operator class implementors
+
+Hybrid Run-Length equality encoding bitmap index
+-------------------------------------------------
+
+In this implementation, each bitmap vector is compressed through a
+hybrid run-length compression scheme, as described below. Each bitmap
+vector is represented in two sections: the header section and the
+content section. The header section contains bits, each of which
+corresponds to a word in the content section. If a bit in the header
+section is 1, then the corresponding word in the content section is a
+compressed word. If the bit is 0, then the corresponding word is not a
+compressed word. For a compressed word in the content section, the
+first bit in this word indicates whether 1s or 0s are compressed. The
+rest of the bits represent the value of "<the number of bits>/<word size>".
+
+Consider this example. Assume that there is a bitmap vector:
+
+   00000000 00000000 01000000 11111111 11111111 11111111
+
+If the size of a word is set to 8, then a compressed form for
+this bitmap vector is as follows:
+
+   header section:   101
+   content section:  00000010 01000000 10000011
+
+Consider the first word in the content section "00000010". The header
+section tells us that this is a compressed word. As the word represents
+the number two, this word tells us that it compresses 16 bits 
+(i.e., 2*8=16). As the first bit is zero, it is compressing zeroed bits.
+
+The second word is uncompressed.
+
+The third word is compressed and it's first bit is set to one. As such
+it compresses ones. As 0011 evaluates to three, this compressed word
+represents 24 bits of ones (3 * 8 = 24).
+
+The insertion algorithm
+-----------------------
+
+The distinct values are stored as a list in LOV (List Of Values) pages
+along with the information about their bitmap vectors, such as the
+first and last pages of their bitmap vectors, the last two words in
+their bitmap vectors, etc. Each entry in LOV pages is called a
+LOV item. To deal with high-cardinality cases, we also create an
+internal heap and a btree index on this heap to speed up searches on
+distinct values. This internal heap stores the distinct values and
+their LOV items in LOV pages, which can be retrieved through the block
+numbers and the offset numbers. In other words, the heap has
+"<number of attributes to be indexed> + 2" attributes (one for the block
+number, the other for the offset number). The btree index is built on
+this heap with the key as attributes to be indexed.
+
+We do not store TIDs in this bitmap index implementation. The reason is
+that TIDs take too much space. The alternative is to convert each tuple
+to a so-called tid location by using this formula:
+
+	((uint64)ItemPointerGetBlockNumber(&ht_ctid) * MaxNumHeapTuples)
+	+ ((uint64)ItemPointerGetOffsetNumber(&ht_ctid));
+
+where MaxNumHeapTuples represents the maximum number of tuples that
+can be stored in a heap. This tid location is used as the index position
+of this bit in its bitmap vector.
+
+Each insertion will affect only one bitmap vector. When inserting a
+new tuple into a bitmap index, we search through the internal heap to
+obtain the block number and the offset number of the LOV page that
+contains the given value. From there, we obtain an exclusive lock on
+that LOV page, and try to insert this new bit into the right bitmap
+vector. The index position for this bit is calculated through the
+formula for the tid location above. There are the following three
+cases:
+
+(1) This bit will only affect the last two words. In this case, we
+    simply update the LOV item.
+(2) This bit will require writing words to the last bitmap page, and
+    the last bitmap page has enough space to store these words. In
+    this case, we obtain an exclusive lock on the last bitmap page,
+    and write those words to the page.
+(3) This bit will require writing words to the last bitmap page, and
+    the last bitmap page does not have enough space for these new words.
+    In this case, we create a new bitmap page, and insert these new
+    words to this new bitmap page. We also update the previous
+    bitmap page and the LOV item.
+
+When building a bitmap index, we also maintain an in-memory buffer to
+store a bunch of tid locations for each distinct value before writing
+them to bitmap vectors in batches. There are two advantages of this
+approach:
+
+(1) The bitmap pages for a bitmap vector are likely to be allocated
+    sequentially.
+(2) This can avoid visiting different bitmap pages for each insert
+    in a sequence of inserts, which can produce a lot of IOs when
+    the cardinality of attributes is high.
+
+Handling tuples that are inserted in the middle of the heap
+-----------------------------------------------------------
+
+When a new tuple is inserted into the middle of the heap, a bit needs
+to be updated in the middle of a bitmap vector. This is called an
+in-place bit update.  Since the bitmap vector is compressed, this
+update may require us to convert one compressed word to 2-3 new
+words. Replacing the old compressed word with these new words may
+cause the current bitmap page to overflow. In this case, we create a
+new bitmap page to store overflown new words, and insert this page
+right after the current bitmap page.
+
+One limitation about this approach is that this may cause a lot of
+fragmentation in a bitmap vector when many tuples are inserted in the
+middle of the heap.
+
+TODO: Currently, we need to search a bitmap vector from the beginning
+to find the bit to be updated. One potential solution is to maintain a
+list of the first tid locations for all bitmap pages in a bitmap
+vector so that we can find the bitmap page that contains
+the bit to be updated without scanning from the beginning.
+
+Vacuum/Vacuum full
+---------------------------
+
+We recreate the bitmap index during vacuum and vacuum full. In particular,
+during vacuuming full, tuples that are re-organized in the heap are not
+inserted into the bitmap index -- we call the re-index after repair_frag().
+
+Notes on operator class implementors
+------------------------------------
+
+This implementation uses the comparison procedures defined for btrees.
+See src/backend/access/nbtree/README for more information.
diff -Naur src.pgsql/backend/access/bitmap/bitmap.c src.bitmap/backend/access/bitmap/bitmap.c
--- src.pgsql/backend/access/bitmap/bitmap.c	1969-12-31 16:00:00.000000000 -0800
+++ src.bitmap/backend/access/bitmap/bitmap.c	2006-09-17 00:09:28.000000000 -0700
@@ -0,0 +1,643 @@
+/*-------------------------------------------------------------------------
+ *
+ * bitmap.c
+ *	Implementation of the Hybrid Run-Length (HRL) on-disk bitmap index.
+ *
+ * Copyright (c) 2006, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	$PostgreSQL$
+ *
+ * NOTES
+ *	This file contains only the public interface routines.
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "access/genam.h"
+#include "access/bitmap.h"
+#include "access/xact.h"
+#include "catalog/index.h"
+#include "miscadmin.h"
+#include "nodes/tidbitmap.h"
+#include "storage/lmgr.h"
+#include "storage/smgr.h"
+#include "parser/parse_oper.h"
+
+static void bmbuildCallback(Relation index,	HeapTuple htup, Datum *attdata,
+							bool *nulls, bool tupleIsAlive,	void *state);
+
+
+/*
+ * bmbuild() -- Build a new bitmap index.
+ */
+Datum
+bmbuild(PG_FUNCTION_ARGS)
+{
+	Relation    heap = (Relation) PG_GETARG_POINTER(0);
+	Relation    index = (Relation) PG_GETARG_POINTER(1);
+	IndexInfo  *indexInfo = (IndexInfo *) PG_GETARG_POINTER(2);
+	double      reltuples;
+	BMBuildState bmstate;
+	IndexBuildResult *result;
+	TupleDesc	tupDesc;
+
+	/* We expect this to be called exactly once. */
+	if (RelationGetNumberOfBlocks(index) != 0)
+		ereport (ERROR,
+				(errcode(ERRCODE_INDEX_CORRUPTED),
+				errmsg("index \"%s\" already contains data",
+				RelationGetRelationName(index))));
+
+	tupDesc = RelationGetDescr(index);
+
+
+	/* XXX: is this correct? Maybe it should be an assertion? */
+	if (tupDesc->natts <= 0)
+		PG_RETURN_VOID();
+
+	/* initialize the bitmap index. */
+	_bitmap_init(index, true);
+
+	/* initialize the build state. */
+	_bitmap_init_buildstate(index, &bmstate);
+
+	/* do the heap scan */
+	reltuples = IndexBuildHeapScan(heap, index, indexInfo,
+								   bmbuildCallback, (void*)&bmstate);
+
+	/*
+	 * fsync the relevant files to disk, unless we're building
+	 * a temporary index
+	 */
+    if (!index->rd_istemp)
+    {
+        RelationOpenSmgr(index);
+        smgrimmedsync(index->rd_smgr);
+
+		RelationOpenSmgr(bmstate.bm_lov_heap);
+        smgrimmedsync(bmstate.bm_lov_heap->rd_smgr);
+
+		RelationOpenSmgr(bmstate.bm_lov_index);
+		smgrimmedsync(bmstate.bm_lov_index->rd_smgr);
+    }
+	/* clean up the build state */
+	_bitmap_cleanup_buildstate(index, &bmstate);
+
+
+
+	 /* return statistics */
+	result = (IndexBuildResult *) palloc(sizeof(IndexBuildResult));
+
+	result->heap_tuples = reltuples;
+	result->index_tuples = bmstate.ituples;
+
+	PG_RETURN_POINTER(result);
+}
+
+
+/*
+ * bminsert() -- insert an index tuple into a bitmap index.
+ */
+Datum
+bminsert(PG_FUNCTION_ARGS)
+{
+	Relation	rel = (Relation) PG_GETARG_POINTER(0);
+	Datum		*datum = (Datum *) PG_GETARG_POINTER(1);
+	bool		*nulls = (bool *) PG_GETARG_POINTER(2);
+	ItemPointer	ht_ctid = (ItemPointer) PG_GETARG_POINTER(3);
+
+	_bitmap_doinsert(rel, *ht_ctid, datum, nulls);
+
+	PG_RETURN_BOOL(true);
+}
+
+/*
+ * bmgettuple() -- return the next tuple in a scan.
+ */
+Datum
+bmgettuple(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	ScanDirection dir = (ScanDirection) PG_GETARG_INT32(1);
+
+	bool res;
+
+	/* 
+	 * If we have already begun our scan, continue in the same direction.
+	 * Otherwise, start up the scan.
+	 */
+	if (ItemPointerIsValid(&(scan->currentItemData)))
+		res = _bitmap_next(scan, dir);
+	else
+		res = _bitmap_first(scan, dir);
+
+	PG_RETURN_BOOL(res);
+}
+
+/*
+ * bmgetbitmap() -- return a stream bitmap.
+ */
+Datum
+bmgetbitmap(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	/* this will be ignored since we return a stream bitmap. */
+	HashBitmap	 *hashBitmap = (HashBitmap*) PG_GETARG_POINTER(1);
+	BlockNumber	  nextBlockNo = PG_GETARG_UINT32(2);
+
+	BMScanPosition	scanPos = ((BMScanOpaque)scan->opaque)->bm_currPos;
+	StreamBitmap *streamBitmap = NULL;
+
+	/* reset entry */
+	if (scanPos != NULL)
+	{
+		MemSet(&(scanPos->bm_streamBitmap.entry), 0, sizeof(PagetableEntry));
+		scanPos->bm_streamBitmap.entry.blockno = nextBlockNo;
+	}
+
+	while (true)
+	{
+		bool	res;
+
+		if (scanPos != NULL)
+			res = _bitmap_nextbatchwords(scan, ForwardScanDirection);
+		else
+		{
+			res = _bitmap_firstbatchwords(scan, ForwardScanDirection);
+			scanPos = ((BMScanOpaque)scan->opaque)->bm_currPos;
+
+			scanPos->bm_streamBitmap.type = T_StreamBitmap;
+			scanPos->bm_result.nextTid = 1;
+		}
+
+		if (!res)
+			break;
+
+		streamBitmap = &(scanPos->bm_streamBitmap);
+
+		if (_bitmap_getbitmapinpage(scanPos->bm_batchWords,
+									&(scanPos->bm_result),
+									nextBlockNo,
+									&(streamBitmap->entry)))
+			break;
+	}
+
+	if (streamBitmap != NULL)
+		streamBitmap->nextBlockNo =
+			streamBitmap->entry.blockno+1;
+
+	PG_RETURN_POINTER(streamBitmap);
+}
+
+/*
+ * bmbeginscan() -- start a scan on the bitmap index.
+ */
+Datum
+bmbeginscan(PG_FUNCTION_ARGS)
+{
+	Relation	rel = (Relation) PG_GETARG_POINTER(0);
+	int			nkeys = PG_GETARG_INT32(1);
+	ScanKey		scankey = (ScanKey) PG_GETARG_POINTER(2);
+	IndexScanDesc scan;
+
+	/* get the scan */
+	scan = RelationGetIndexScan(rel, nkeys, scankey);
+
+	PG_RETURN_POINTER(scan);
+}
+
+/*
+ * bmrescan() -- restart a scan on the bitmap index.
+ */
+Datum
+bmrescan(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc	scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	ScanKey			scankey = (ScanKey) PG_GETARG_POINTER(1);
+	BMScanOpaque	so = (BMScanOpaque) scan->opaque;
+	BMBitmapScanPosition	sp;
+
+	/* so will be NULL if we were called via index_rescan() */
+	if (so == NULL)
+	{
+		so = (BMScanOpaque) palloc(sizeof(BMScanOpaqueData));
+		so->bm_currPos = NULL;
+		so->bm_markPos = NULL;
+		scan->opaque = so;
+	}
+
+	if (so->bm_currPos != NULL)
+	{
+		uint32 i;
+		
+
+		/*
+		 * release the buffers that have been stored for each related 
+		 * bitmap vector.
+		 */
+		sp = so->bm_currPos->bm_bitmapScanPos;
+
+		for (i=0; i<so->bm_currPos->bm_numBitmapVectors; i++)
+		{
+			if (!so->bm_currPos->isstream && BufferIsValid((sp[i]).bm_lovBuffer))
+				ReleaseBuffer((sp[i]).bm_lovBuffer);
+
+			_bitmap_cleanup_batchwords((sp[i]).bm_batchWords);
+
+			if (sp[i].bm_batchWords != NULL)
+				pfree((sp[i]).bm_batchWords);
+		}
+		pfree(sp);
+		so->bm_currPos = NULL;
+	}
+
+	if (so->bm_markPos != NULL)
+	{
+		uint32 i;
+		sp = so->bm_markPos->bm_bitmapScanPos;
+
+		for (i=0; i<so->bm_currPos->bm_numBitmapVectors; i++)
+		{
+			if (!so->bm_markPos->isstream && BufferIsValid((sp[i]).bm_lovBuffer))
+				ReleaseBuffer((sp[i]).bm_lovBuffer);
+
+			_bitmap_cleanup_batchwords((sp[i]).bm_batchWords);
+
+			if (sp[i].bm_batchWords != NULL)
+				pfree((sp[i]).bm_batchWords);
+		}
+
+		pfree(sp);
+		so->bm_markPos = NULL;
+	}
+
+	/* reset the scan key */
+	if (scankey && scan->numberOfKeys > 0)
+		memmove(scan->keyData, scankey,
+				scan->numberOfKeys * sizeof(ScanKeyData));
+
+	ItemPointerSetInvalid(&scan->currentItemData);
+	
+	PG_RETURN_VOID();
+}
+
+/*
+ * bmendscan() -- close a scan.
+ */
+Datum
+bmendscan(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc	scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	BMScanOpaque	so = (BMScanOpaque) scan->opaque;
+
+	BMBitmapScanPosition	bmScanPos;
+	uint32 keyNo;
+
+	/* free the space */
+	/* XXX: this should be pushed into a seperate routine as it is duplicated
+	 * from above */
+	if (so->bm_currPos != NULL)
+	{
+		/* release the buffers that have been stored for each related bitmap */
+		bmScanPos = so->bm_currPos->bm_bitmapScanPos;
+
+		for (keyNo=0; keyNo<so->bm_currPos->bm_numBitmapVectors; keyNo++)
+		{
+			if (BufferIsValid((bmScanPos[keyNo]).bm_lovBuffer))
+				ReleaseBuffer((bmScanPos[keyNo]).bm_lovBuffer);
+
+			_bitmap_cleanup_batchwords((bmScanPos[keyNo]).bm_batchWords);
+			if (bmScanPos[keyNo].bm_batchWords != NULL)
+				pfree((bmScanPos[keyNo]).bm_batchWords);
+		}
+
+		pfree(bmScanPos);
+		pfree(so->bm_currPos);
+		so->bm_currPos = NULL;
+	}
+
+	if (so->bm_markPos != NULL)
+	{
+		bmScanPos = so->bm_markPos->bm_bitmapScanPos;
+
+		for (keyNo=0; keyNo<so->bm_currPos->bm_numBitmapVectors; keyNo++)
+		{
+			if (BufferIsValid((bmScanPos[keyNo]).bm_lovBuffer))
+				ReleaseBuffer((bmScanPos[keyNo]).bm_lovBuffer);
+			_bitmap_cleanup_batchwords((bmScanPos[keyNo]).bm_batchWords);
+			if (bmScanPos[keyNo].bm_batchWords != NULL)
+				pfree((bmScanPos[keyNo]).bm_batchWords);
+		}
+
+		pfree(bmScanPos);
+		pfree(so->bm_markPos);
+		so->bm_markPos = NULL;
+	}
+
+	pfree(so);
+
+	scan->opaque = NULL;
+
+	if (ItemPointerIsValid(&(scan->currentItemData)))
+		ItemPointerSetInvalid(&(scan->currentItemData));
+	if (ItemPointerIsValid(&(scan->currentMarkData)))
+		ItemPointerSetInvalid(&(scan->currentMarkData));
+
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * bmmarkpos() -- save the current scan position.
+ */
+Datum
+bmmarkpos(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc	scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	BMScanOpaque	so = (BMScanOpaque) scan->opaque;
+
+	BMBitmapScanPosition	bmScanPos;
+	uint32 vectorNo;
+
+	/* free the space */
+	if (ItemPointerIsValid(&(scan->currentMarkData)))
+	{
+		/*
+		 * release the buffers that have been stored for each
+		 * related bitmap.
+		 */
+		bmScanPos = so->bm_markPos->bm_bitmapScanPos;
+
+		for (vectorNo=0; vectorNo<so->bm_markPos->bm_numBitmapVectors;
+			 vectorNo++)
+		{
+			if (BufferIsValid((bmScanPos[vectorNo]).bm_lovBuffer))
+			{
+				ReleaseBuffer((bmScanPos[vectorNo]).bm_lovBuffer);
+				(bmScanPos[vectorNo]).bm_lovBuffer = InvalidBuffer;
+			}
+		}
+		
+		ItemPointerSetInvalid(&(scan->currentMarkData));
+	}
+
+	if (ItemPointerIsValid(&(scan->currentItemData)))
+	{
+		uint32	size = sizeof(BMScanPositionData);
+
+
+		/* set the mark position */
+		if (so->bm_markPos == NULL)
+		{
+			so->bm_markPos = (BMScanPosition) palloc(size);
+		}
+
+		bmScanPos = so->bm_currPos->bm_bitmapScanPos;
+
+		for (vectorNo=0; vectorNo<so->bm_currPos->bm_numBitmapVectors;
+			 vectorNo++)
+		{
+			if (BufferIsValid((bmScanPos[vectorNo]).bm_lovBuffer))
+				IncrBufferRefCount((bmScanPos[vectorNo]).bm_lovBuffer);
+		}
+
+		memcpy(so->bm_markPos->bm_bitmapScanPos, bmScanPos,
+			   so->bm_currPos->bm_numBitmapVectors *
+			   sizeof(BMBitmapScanPositionData));
+		memcpy(so->bm_markPos, so->bm_currPos, size);
+
+		scan->currentMarkData = scan->currentItemData;
+	}
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * bmrestrpos() -- restore a scan to the last saved position.
+ */
+Datum
+bmrestrpos(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc	scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	BMScanOpaque	so = (BMScanOpaque) scan->opaque;
+
+	BMBitmapScanPosition	bmScanPos;
+	uint32 vectorNo;
+
+	/* free space */
+	if (ItemPointerIsValid(&(scan->currentItemData)))
+	{
+		/* release the buffers that have been stored for each related bitmap.*/
+		bmScanPos = so->bm_currPos->bm_bitmapScanPos;
+
+		for (vectorNo=0; vectorNo<so->bm_markPos->bm_numBitmapVectors;
+			 vectorNo++)
+		{
+			if (BufferIsValid((bmScanPos[vectorNo]).bm_lovBuffer))
+			{
+				ReleaseBuffer((bmScanPos[vectorNo]).bm_lovBuffer);
+				(bmScanPos[vectorNo]).bm_lovBuffer = InvalidBuffer;
+			}
+		}
+
+		ItemPointerSetInvalid(&(scan->currentItemData));
+	}
+
+	if (ItemPointerIsValid(&(scan->currentMarkData)))
+	{
+		uint32	size = sizeof(BMScanPositionData);
+
+		/* set the current position */
+		if (so->bm_currPos == NULL)
+		{
+			so->bm_currPos = (BMScanPosition) palloc(size);
+		}
+
+		bmScanPos = so->bm_markPos->bm_bitmapScanPos;
+
+		for (vectorNo=0; vectorNo<so->bm_currPos->bm_numBitmapVectors;
+			 vectorNo++)
+		{
+			if (BufferIsValid((bmScanPos[vectorNo]).bm_lovBuffer))
+				IncrBufferRefCount((bmScanPos[vectorNo]).bm_lovBuffer);
+		}		
+
+		memcpy(so->bm_currPos->bm_bitmapScanPos, bmScanPos,
+			   so->bm_markPos->bm_numBitmapVectors *
+			   sizeof(BMBitmapScanPositionData));
+		memcpy(so->bm_currPos, so->bm_markPos, size);
+		scan->currentItemData = scan->currentMarkData;
+	}
+
+	PG_RETURN_VOID();
+}
+
+/*
+ * bmbulkdelete() -- bulk delete index entries
+ *
+ * Re-index is performed before retrieving the number of tuples
+ * indexed in this index.
+ */
+Datum
+bmbulkdelete(PG_FUNCTION_ARGS)
+{
+	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
+	Relation	rel = info->index;
+	IndexBulkDeleteResult* volatile result =
+		(IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
+	double		numTuples;
+	bool		needRebuild = false;
+	Buffer		metabuf;
+	BMMetaPage	metapage;
+
+	/* allocate stats if first time through, else re-use existing struct */
+	if (result == NULL)
+		result = (IndexBulkDeleteResult *)
+			palloc0(sizeof(IndexBulkDeleteResult));	
+
+	if (!info->vacuum_full)
+	{
+		/* obtain the indicator if this index needs to be re-built. */
+		metabuf = _bitmap_getbuf(rel, BM_METAPAGE, BM_READ);
+		metapage = (BMMetaPage)PageGetContents(BufferGetPage(metabuf));
+		needRebuild = metapage->bm_need_rebuilt;
+		_bitmap_relbuf(metabuf);
+	}
+
+	if (needRebuild || info->vacuum_full)
+	{
+		reindex_index(RelationGetRelid(rel));
+		CommandCounterIncrement();
+	}
+
+	/* obtain the number of tuples from the index */
+	metabuf = _bitmap_getbuf(rel, BM_METAPAGE, BM_READ);
+	metapage = (BMMetaPage)PageGetContents(BufferGetPage(metabuf));
+	numTuples = metapage->bm_num_tuples;
+	_bitmap_relbuf(metabuf);
+	
+	result = (IndexBulkDeleteResult *) palloc0(sizeof(IndexBulkDeleteResult));
+	result->num_pages = RelationGetNumberOfBlocks(rel);
+	result->num_index_tuples = numTuples;
+	result->tuples_removed = 0;
+	
+	PG_RETURN_POINTER(result);
+}
+
+/*
+ * bmvacuumcleanup() -- post-vacuum cleanup.
+ *
+ * We do nothing useful here.
+ */
+Datum
+bmvacuumcleanup(PG_FUNCTION_ARGS)
+{
+	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
+	Relation	rel = info->index;
+	IndexBulkDeleteResult *stats = 
+			(IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
+
+	if(stats == NULL)
+		stats = (IndexBulkDeleteResult *)palloc0(sizeof(IndexBulkDeleteResult));
+
+	/* update statistics */
+	stats->num_pages = RelationGetNumberOfBlocks(rel);
+	stats->pages_deleted = 0;
+	stats->pages_free = 0;
+	/* XXX: dodgy hack to shutup index_scan() and vacuum_index() */
+	stats->num_index_tuples = info->num_heap_tuples;
+
+	PG_RETURN_POINTER(stats);
+}
+
+/*
+ * bmgetbitmapwords() -- return a given number of bitmap words in a scan.
+ */
+Datum
+bmgetbitmapwords(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc	scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	uint32			maxNumOfBitmapWords = PG_GETARG_UINT32(1);
+	uint32		   *returnedNumOfBitmapWords = (uint32 *) PG_GETARG_POINTER(2);
+	BM_HRL_WORD	   *bitmapHeaderWords = (BM_HRL_WORD *) PG_GETARG_POINTER(3);
+	BM_HRL_WORD	   *bitmapContentWords = (BM_HRL_WORD *) PG_GETARG_POINTER(4);
+	bool		 	res = false;
+
+	Assert(maxNumOfBitmapWords > 0);
+	Assert((maxNumOfBitmapWords % BM_HRL_WORD_SIZE) == 0);
+	Assert((maxNumOfBitmapWords % BM_NUM_OF_HRL_WORDS_PER_PAGE) == 0);
+
+	*returnedNumOfBitmapWords = 0;
+	while (*returnedNumOfBitmapWords < maxNumOfBitmapWords)
+	{
+		BMScanPosition	scanPos;
+		int32			numOfWords = 0;
+
+		if (((BMScanOpaque)scan->opaque)->bm_currPos != NULL)
+			res = _bitmap_nextbatchwords(scan, ForwardScanDirection);
+		else
+			res = _bitmap_firstbatchwords(scan, ForwardScanDirection);
+
+		if (!res)
+			break;
+
+		scanPos = ((BMScanOpaque) scan->opaque)->bm_currPos;
+		if (scanPos->bm_batchWords->numOfWords >= 
+			(maxNumOfBitmapWords - *returnedNumOfBitmapWords))
+			numOfWords = maxNumOfBitmapWords - *returnedNumOfBitmapWords;
+		else
+			numOfWords = scanPos->bm_batchWords->numOfWords;
+
+		/* copy the content words */
+		/* XXX: is this necessary? */
+		memcpy(bitmapContentWords + *returnedNumOfBitmapWords,
+			   scanPos->bm_batchWords->bitmapContentWords +
+			   scanPos->bm_batchWords->startNo,
+			   numOfWords*sizeof(BM_HRL_WORD));
+
+		/* copy the header words */
+		memcpy(bitmapHeaderWords +
+				(*returnedNumOfBitmapWords)/BM_HRL_WORD_SIZE,
+				scanPos->bm_batchWords->bitmapHeaderWords +
+				scanPos->bm_batchWords->startNo/BM_HRL_WORD_SIZE,
+				(numOfWords/BM_HRL_WORD_SIZE + 
+				((numOfWords%BM_HRL_WORD_SIZE == 0) ? 0 : 1))*
+				 sizeof(BM_HRL_WORD));
+
+		*returnedNumOfBitmapWords += numOfWords;
+
+		if (numOfWords == scanPos->bm_batchWords->numOfWords)
+		{
+			_bitmap_reset_batchwords(scanPos->bm_batchWords);
+		}
+		else
+		{
+			/* modify scanPos->bm_batchWords */
+			scanPos->bm_batchWords->startNo += numOfWords;
+			scanPos->bm_batchWords->numOfWords -= numOfWords;
+		}
+
+		if (*returnedNumOfBitmapWords%BM_HRL_WORD_SIZE != 0)
+			break;
+	}
+
+	if (*returnedNumOfBitmapWords > 0)
+		PG_RETURN_BOOL(true);
+	else
+		PG_RETURN_BOOL(false);
+}
+
+/*
+ * Per-tuple callback from IndexBuildHeapScan
+ */
+static void
+bmbuildCallback(Relation index, HeapTuple htup, Datum *attdata,
+				bool *nulls, bool tupleIsAlive,	void *state)
+{
+	BMBuildState *bstate = (BMBuildState *) state;
+
+	_bitmap_buildinsert(index, htup->t_self, attdata, nulls, bstate);
+	bstate->ituples += 1;
+}
